//--------------------------------------------------------------
// Press F1 to get help about using script.
// To access an object that is not located in the current class, start the call with Globals.
// When using events and timers be cautious not to generate memoryleaks,
// please see the help for more information.
//---------------------------------------------------------------

namespace Neo.ApplicationFramework.Generated
{
    using System.Windows.Forms;
    using System;
    using System.Drawing;
    using Neo.ApplicationFramework.Tools;
	using Neo.ApplicationFramework.Tools.Security;
    using Neo.ApplicationFramework.Common.Graphics.Logic;
    using Neo.ApplicationFramework.Controls;
    using Neo.ApplicationFramework.Interfaces;
    
	using Neo.ApplicationFramework.Common.Service;
    
    public partial class AddUsersFromTags
    {
		public static void AddUser(string username, string password)
		{
			//We will add all new users to the GROUP for lack of anything
			//better to do.
			const string GROUP = "Operators";
			
			ISecurityManager securityManager = Globals.Security as ISecurityManager;
			ISecurityUser newUser = new SecurityUser();
			PasswordHasherCF hasher = new PasswordHasherCF();
			
			//Create the new users here
			newUser.Username = username;
			newUser.Password = password;
			
			//The ISecurityUser will not create the password hash for us, so we need to do it
			newUser.PasswordHash = hasher.GetPasswordHash(password);
			
			//Because the group is a enum, and we only know the name of the group
			//we want our new user to be in, we need to cycle through the
			//security groups and find out what number is associated with the 
			//security group we want.
			foreach(ISecurityGroup aGroup in securityManager.Groups )
			{
				if(aGroup.GroupName == GROUP)
				{
					newUser.AddToGroup(aGroup.Group);
					Globals.Tags.Tag1.Value = aGroup.GroupName;
					break;
				}
			}
			
			//All done, lets add the new user to the HMI's security system
			securityManager.AddUser(newUser);
			
			//Now save the new security file. If you do not do this, then the above changes will
			//be lost on the next HMI power cycle!
			ISecurityServiceCF securityServiceCF = ServiceContainerCF.GetService<ISecurityServiceCF>();
			securityServiceCF.Save(securityManager.FilePath);
		}
    }
}
